export class Review {
  id: number | undefined;
  resource: string | undefined;
  users: string[] | undefined;
  status: string[] | undefined;
  comments: ReviewComment[] | undefined;
  requestedBy: string | undefined;
  link: string | undefined;
  badgeRewarded: boolean | undefined;
  resourceID: string | undefined;

  constructor(resource: string, users: string[], status: string[], comments: ReviewComment[]) {
    this.resource = resource;
    this.users = users;
    this.status = status;
    this.comments = comments;
  }
}

export class ReviewComment {
  descriptionIsClear: boolean | undefined;
  requirementsAreClear: boolean | undefined;
  descriptionComment: string | undefined;

  informationRequiredComplete: boolean | undefined;
  allMaterialsAvailable: boolean | undefined;
  informationRequiredComment: string | undefined;

  isStructured: boolean | undefined;
  subExercisesAreClear: boolean | undefined;
  structuredComment: string | undefined;

  solutionIsCorrect: boolean | undefined;
  solutionComment: string | undefined;

  metadataIsComplete: boolean | undefined;
  metadataIsCorrect: boolean | undefined;
  metadataComment: string | undefined;

  constructor(
    descriptionIsClear: boolean,
    requirementsAreClear: boolean,
    descriptionComment: string,
    informationRequiredComplete: boolean,
    allMaterialsAvailable: boolean,
    informationRequiredComment: string,
    isStructured: boolean,
    subExercisesAreClear: boolean,
    structuredComment: string,
    solutionIsCorrect: boolean,
    solutionComment: string,
    metadataIsComplete: boolean,
    metadataIsCorrect: boolean,
    metadataComment: string
  ) {
    this.descriptionIsClear = descriptionIsClear;
    this.requirementsAreClear = requirementsAreClear;
    this.descriptionComment = descriptionComment;
    this.informationRequiredComplete = informationRequiredComplete;
    this.allMaterialsAvailable = allMaterialsAvailable;
    this.informationRequiredComment = informationRequiredComment;
    this.isStructured = isStructured;
    this.subExercisesAreClear = subExercisesAreClear;
    this.structuredComment = structuredComment;
    this.solutionIsCorrect = solutionIsCorrect;
    this.solutionComment = solutionComment;
    this.metadataIsComplete = metadataIsComplete;
    this.metadataIsCorrect = metadataIsCorrect;
    this.metadataComment = metadataComment;
  }
}

export class ReviewStatisticsDTO {
  reviewInProgress = 0;
  reviewImprovementRequested = 0;
  reviewImproved = 0;
  reviewCompleted = 0;
  reviewRequested = 0;
  unknownStats = 0;
  reviewsAssignedToReviewer = 0;
  reviewImprovedForReviewer = 0;
  reviewRejectedByReviewer = 0;
  reviewInProgressByReviewer = 0;
  reviewImprovementRequestedByReviewer = 0;
  reviewCompletedByReviewer = 0;
  unkownStatsByReviewer = 0;
  badgesRewarded = 0;
}
